<?php

class ActionQuantik{
    //attributs
    protected PlateauQuantik $plateau;
    //constructeurs
    public function __construct(PlateauQuantik $plateau){
        $this->plateau = $plateau;
    }

    public function getPlateau():PlateauQuantik {
        return $this->plateau;
    }

    public function isRowWin(int $numRow):bool {
        $arrPiece = $this->plateau->getRow($numRow);
        return self::isComboWin($arrPiece);
    }

    public function isColWin(int $numCol):bool {
        $arrPiece = $this->plateau->getCol($numCol);
        return self::isComboWin($arrPiece);
    }

    public function isCornerWin(int $dir): bool {
        $arrPiece = $this->plateau->getCorner($dir);
        return self::isComboWin($arrPiece);
    }

    public function isValidePose(int $rowNum, int $colNum, PieceQuantik $piece): bool{
        $colonne = $this->plateau->getCol($colNum);
        $colonne = $this->plateau->getCol($colNum);
    }

    private static function isComboWin(ArrayPieceQuantik $pieces): bool{
        $formeInitiale = $pieces->getPieceQuantik(0)->getForme();
        for($i = 1; $i < $pieces->count(); $i++){
            if($formeInitiale === $pieces->getPieceQuantik($i)->getForme() || $formeInitiale == 0){
                return false;
            }
        }
        return true;
    }
    private static function isPieceValide(ArrayPieceQuantik $pieces, PieceQuantik $p): bool{
        $pieceInitiale = $pieces->getPieceQuantik(0);
        for($i = 0; $i < $pieces->count(); $i++){
            if($pieceInitiale->getForme() === $p->getForme()){
                if($pieceInitiale->getCouleur() === $p->getCouleur()){
                    return false;
                }
            }
        }
        return true;
    }
}